public class Hex {
    private static final char[] hexDigits = {
        '0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'
    };

    public static String spacer(char c, int width) {
        char[] buf = new char[width];
        for (int i = width-1; i >= 0; i--) {
            buf[i] = c;
        }
        return new String(buf);
    }        

    public static String toString(int x, int width) {
        if (x < 0) return spacer('?', width);

        char[] buf = new char[width];
        for (int i = width-1; i >= 0; i--) {
            buf[i] = hexDigits[x & 0x0F];
            x >>>= 4;
        }
        return new String(buf);
    }

    public static String toString(int x, int y, int width) {
        if (x < 0 || y < 0) return spacer('?', width*2);

        char[] buf = new char[width*2];
        for (int i = width-1; i >= 0; i--) {
            buf[i] = hexDigits[x & 0x0F];
            x >>>= 4;
        }
        for (int i = width*2-1; i >= width; i--) {
            buf[i] = hexDigits[y & 0x0F];
            y >>>= 4;
        }
        return new String(buf);
    }
}
