import java.util.Random;

/**
 * A utility class for generating random numbers.
 */
public class RNG {
    private static Random random = new Random();

    /**
     * Return an integer from 0..N.
     * mask MUST be 2**n - 1 for some n.
     */
    public static int rand0thruN(int mask, int N) {
        int b;
        do {
            b = random.nextInt();  // 32-bit value
            b ^= b >> 16;
            b ^= b >> 8;
            b &= mask;  // b is 0..mask
        } while (b > N);
        return b;
    }
}
